# Examen du 22/04/2024 de Programmation web 2

## Consignes

Vous avez 1h30 pour réaliser cet examen. Vous devez rendre votre travail sur Gitlab.

Vous avez le droit de consulter :

- vos notes de cours
- le cours
- votre projet
- internet

**Il est interdit d'utiliser des IAs** !

Pour récupérer l'examen, commencez par forker ce projet en cliquant sur le bouton en haut à droite de la page du
projet :   
![fork](./public/fork.png)

Vous arrivez alors sur cette page :

![forked](./public/fork-step.png)

/!\ **Attention** /!\ : Ajoutez bien le projet à votre namespace personnel (ici, `marco`). Pour la
partie `Project slug`, vous pouvez laisser le nom par défaut.

Vous devrez ensuite ajouter le professeur en tant que membre de votre projet. Pour cela, allez
dans `Manage` > `Members` > `Invite members` et ajoutez le professeur avec le rôle `Maintainer`.

Le projet est alors rattaché à votre compte Gitlab. Vous devrez ainsi faire un clone de ce projet qui est rattaché à
**VOTRE COMPTE** !

Exemple :

```bash
git clone git@git.unistra.fr:<mon-username>/examen-22-04-2024.git
```

... ou si vous n'avez pas configuré votre clé SSH :

```bash
git clone https://git.unistra.fr/<mon-username>/examen-22-04-2024.git
```

## Questions (25 points)

L'ensemble des questions est sur 25 points, la note sera ramenée sur 20 avec un produit en croix.

Ci-dessous, veuillez trouver :

- une description sommaire de chaque question. Pour plus de détails, référez-vous aux commentaires dans les fichiers
  correspondants.
- des questions auxquelles vous devrez répondre directement dans ce fichier, sous chaque question. Pour ces questions,
  **NE PAS FAIRE** de copier/coller d'internet, merci de donner des réponses avec vos propres mots, même si elles sont
  moins précises ou moins bien formulées.

### AJAX (6 points)

Vous devrez créer une requête AJAX dans le fichier : `ajax.js`. **(3 points)**

**Questions Javascript** :

- Qu'est-ce que AJAX ? Quel est son intérêt ? **(1 point)**
  l'utilisation de ajax nous permet de charger des parties de la page web sans avoir besoin de recharger la page entierement , ainsi nous permettant d'avoir une page plus "smooth", plus responsive. 


- Donnez deux cas d'usage où AJAX est particulièrement utile.
  soit lorsque lon charge queleque chose apartir d'une base de donnees, exemple losque lon atteint le bas d'une page en peux charger en continue sans avoir a recharger la page.


 **(2 points)**

### HTML (8 points)

Vous devrez réaliser un formulaire de création de compte dans le fichier : `index.html` dans la
section `<section id="signup">`. **(3 points)**

**Questions HTML** :

- Expliquez les points de vigilance quand on crée un formulaire en HTML par rapport à l'accessibilité ou aux bonnes pratiques par exemple. **(2 points)**

  ajouter des label avant chaque balise de input pour informe son utilité, 
  
  afin de permettre a l'utilisateur de bien savoir ce qui est demandé mettre placeholder tel que "addressMail", " pswrd"..
  
  verification de l'etat de l'etats du formulaire, exemple pour les address avoire le '@', les mpd , la taille max/min

  
- Expliquez les deux attributs dans la balise `<form>` qui vous sont nécessaires ici pour créer votre formulaire. 
**(1 point)**
les attribut neccesaire sont le input et le boutton, car on chercher a obtenir une saisie et logiquement un fois terminer on dois pouvoir la transmezttre.

- Expliquez la ou les différences entre les méthodes GET et POST. Quand utiliser l'une ou l'autre ? **(2 points)**

 a al base les deux permettent de transferer des donnes du client au serveur:

  GET transmet via via l'URL, moin secure car les donne visible dans l'url 
  POST transmet par requete, plus secure car donne caché dans le corps de la requete 

### PHP (8 points)

Vous devrez réaliser un script PHP qui permet d'insérer les données envoyées par le formulaire ci-dessus dans la base de
données. **(5 points)**

**Questions PHP** :

- Expliquez les points d'attention à avoir quand on traite des données provenant d'un formulaire et qu'on insère
  celles-ci dans une base de données. **(3 points)**

cest une question de securité, se proteger contre les injections sql en faisant des verifications, aisni controler la taille des mdp, le formatat des saisies 


### CSS (3 points)

Vous devrez réaliser un style CSS pour la liste des projets pour qu'elle ressemble à **(3 points)** :  
![index](./public/index.png)    
