const initProjects = async () => {

    /**
     * AJAX
     *
     * Faire une requête AJAX à l'API : /api.php
     * L'objet récupéré est un tableau d'objets.
     * L'objet contient les propriétés suivantes :
     * - id : number
     * - title : string
     * - date : string (format : YYYY-MM-DD)
     * - content : string
     *
     * Créer un article pour chaque objet récupéré (pour le format cf. les articles actuellement dans le fichier index.html).
     * L'article contient un titre (h2), une date (p) et un contenu (p).
     * Ajouter chaque article créé dans la section "articles" du fichier index.html à la place des éléments existants.
     */

    try {
        var response = await fetch('/api.php');
        
        if (!response.ok) {
            throw new Error('repon pas ');
        }

        var projects = await response.json();
        var projectSection = document.querySelector('.project');

        projectSection.innerHTML = ''; 

        projects.forEach(project => {
            var article = document.createElement('article');

            var title = document.createElement('h2');
            title.textContent = project.title;

            var date = document.createElement('i');
            date.textContent = project.date;

            var content = document.createElement('p');
            content.textContent = project.content;
            
            article.appendChild(title);
            article.appendChild(date);
            article.appendChild(content);

            projectSection.appendChild(article);
        });
    } catch (error) {
        console.error('errers de fetching des projets', error);
    }
}

initProjects();
